CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

反向方法 (ActiveX)

2023-1-4 04:10| 发布者: admin| 查看: 614| 评论: 0|来自: AutoCAD

摘要: 反转样条曲线的方向。

反转样条曲线的方向。

支持的平台:仅窗口

签名

工 务 局:

object.Reverse
对象

类型:样条

此方法适用的对象。

返回值(RetVal)

无返回值。

言论

没有额外的评论。

例子

工 务 局:

Sub Example_Reverse()
    ' This example creates a spline in model space.
    ' It then reverses the spline and therefore the
    ' control point data.
    
    Dim splineObj As AcadSpline
    Dim startTan(0 To 2) As Double
    Dim endTan(0 To 2) As Double
    Dim fitPoints(0 To 8) As Double
    Dim msg As String
    
    startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0
    endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0
    fitPoints(0) = 0: fitPoints(1) = 0: fitPoints(2) = 0
    fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0
    fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    
    ZoomAll
    GoSub GETPOINTS
    MsgBox "Before the reverse the first control point is " & msg

    ' Reverse the Spline and therefore control point data
    splineObj.Reverse

    ThisDrawing.Regen True
    GoSub GETPOINTS
    MsgBox "After the reverse the first control point is " & msg

    Exit Sub
GETPOINTS:
    msg = ""
    ' Get the coordinates from the first control point again
    Dim count As Integer
    For count = 0 To 2
        msg = msg & splineObj.GetControlPoint(0)(count) & ", "
    Next
    msg = VBA.Left(msg, Len(msg) - 2)
    Return
    
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_Reverse()
    ;; This example creates a spline in model space.
    ;; It then reverses the spline and therefore the
    ;; control point data.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))

    ;; Create the spline
    (setq startTan (vlax-3d-point 0.5 0.5 0)
          endTan (vlax-3d-point 0.5 0.5 0)
          fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8)))
    (vlax-safearray-fill fitPoints '(0 0 0
				                                 5 5 0
				                                 10 0 0
				                                )
    )

    (setq modelSpace (vla-get-ModelSpace doc))
    (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan))

    (vla-ZoomAll acadObj)

    ;; Get the coordinates from the first control point again
    (setq msg ""
          count 0)
    (while (>= 2 count)
        (setq msg (strcat msg (rtos (vlax-safearray-get-element (vlax-variant-value (vla-GetControlPoint splineObj 0)) count) 2) ", ")
              count (1+ count)
        )
    )
    (setq msg (vl-string-right-trim ", " msg))

    (alert (strcat "Before the reverse the first control point is " msg))

    ;; Reverse the Spline and therefore control point data
    (vla-Reverse splineObj)

    (vla-Regen doc :vlax-true)
  
    ;; Get the coordinates from the first control point again
    (setq msg ""
          count 0)
    (while (>= 2 count)
        (setq msg (strcat msg (rtos (vlax-safearray-get-element (vlax-variant-value (vla-GetControlPoint splineObj 0)) count) 2) ", ")
              count (1+ count)
        )
    )
    (setq msg (vl-string-right-trim ", " msg))

    (alert (strcat "After the reverse the first control point is " msg))
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-12 07:14

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部